## orthanc 0.1.0

=== DESCRIPTION ===
Package: orthanc
Title: Programmatic Interface to 'Orthanc' DICOM Servers
Version: 0.1.0
Authors@R: 
    person("Matthew T.", "Warkentin", , "matthew.warkentin@ucalgary.ca", role = c("aut", "cre", "cph"),
           comment = c(ORCID = "0000-0001-8730-3511"))
Description: An R Interface to 'Orthanc' DICOM servers for medical imaging workflows.
    'Orthanc' is a lightweight, open-source DICOM server that exposes a comprehensive
    REST API for managing, querying, retrieving, and modifying DICOM resources 
    (<https://www.orthanc-server.com>). The goal of this package is to provide 
    comprehensive and user-friendly access to the 'Orthanc' REST API, designed to 
    align with idiomatic R workflows while preserving the structure and semantics
    of DICOM resources.
License: MIT + file LICENSE
Encoding: UTF-8
RoxygenNote: 7.3.3.9000
Depends: R (>= 4.1.0)
Imports: carrier (>= 0.3.0), digest, glue, fs, httr2, jsonlite, mirai
        (>= 2.5.1), purrr (>= 1.1.0), R6, rlang
URL: https://github.com/mattwarkentin/orthanc,
        https://mattwarkentin.github.io/orthanc/
BugReports: https://github.com/mattwarkentin/orthanc/issues
NeedsCompilation: no
Packaged: 2026-02-24 23:09:38 UTC; matt
Author: Matthew T. Warkentin [aut, cre, cph] (ORCID:
    <https://orcid.org/0000-0001-8730-3511>)
Maintainer: Matthew T. Warkentin <matthew.warkentin@ucalgary.ca>
Repository: CRAN
Date/Publication: 2026-03-03 10:20:10 UTC

## orthanc 0.4.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(Orthanc)

# Version of the build, should always be "mainline" except in release branches
add_definitions(
  -DORTHANC_VERSION="0.4.0"
  )

# Parameters of the build
SET(STATIC_BUILD ON CACHE BOOL "Static build of the third-party libraries (necessary for Windows)")
SET(STANDALONE_BUILD OFF CACHE BOOL "Standalone build (all the resources are embedded, necessary for releases)")
SET(ENABLE_SSL ON CACHE BOOL "Include support for SSL")
SET(BUILD_UNIT_TESTS ON CACHE BOOL "Build the unit tests")

# Advanced parameters (for Debian packaging)
SET(USE_DYNAMIC_JSONCPP OFF CACHE BOOL "Use the dynamic version of JsonCpp (only for Debian sid)")
SET(USE_DYNAMIC_GOOGLE_LOG ON CACHE BOOL "Use the dynamic version of Google Log")
SET(USE_DYNAMIC_GOOGLE_TEST ON CACHE BOOL "Use the dynamic version of Google Test (not for Debian sid)")
SET(USE_DYNAMIC_SQLITE ON CACHE BOOL "Use the dynamic version of SQLite")
SET(DEBIAN_FORCE_HARDENING OFF CACHE BOOL "Force the injection of Debian hardening flags (unrecommended)")
SET(DEBIAN_USE_GTEST_SOURCE_PACKAGE OFF CACHE BOOL "Use the sources of Google Test shipped with libgtest-dev (only for Debian sid)")
SET(ONLY_CORE_LIBRARY OFF CACHE BOOL "Only build the core library")

mark_as_advanced(USE_DYNAMIC_JSONCPP)
mark_as_advanced(USE_DYNAMIC_GOOGLE_LOG)
mark_as_advanced(USE_DYNAMIC_GOOGLE_TEST)
mark_as_advanced(USE_DYNAMIC_SQLITE)
mark_as_advanced(DEBIAN_FORCE_HARDENING)
mark_as_advanced(DEBIAN_USE_STATIC_GOOGLE_TEST)
mark_as_advanced(ONLY_CORE_LIBRARY)

# Some basic inclusions
include(CheckIncludeFiles)
include(CheckIncludeFileCXX)
include(${CMAKE_SOURCE_DIR}/Resources/CMake/AutoGeneratedCode.cmake)
include(${CMAKE_SOURCE_DIR}/Resources/CMake/DownloadPackage.cmake)
include(${CMAKE_SOURCE_DIR}/Resources/CMake/Compiler.cmake)

# Configuration of the standalone builds
if (${CMAKE_CROSSCOMPILING})
  # Cross-compilation implies the standalone build
  SET(STANDALONE_BUILD ON)
endif()

# Prepare the third-party dependencies
SET(THIRD_PARTY_SOURCES
  ${CMAKE_SOURCE_DIR}/Resources/md5/md5.c
  ${CMAKE_SOURCE_DIR}/Resources/base64/base64.cpp
  ${CMAKE_SOURCE_DIR}/Resources/sha1/sha1.cpp
  )

include(${CMAKE_SOURCE_DIR}/Resources/CMake/GoogleLogConfiguration.cmake)

if (${ENABLE_SSL})
  add_definitions(-DORTHANC_SSL_ENABLED=1)
  include(${CMAKE_SOURCE_DIR}/Resources/CMake/OpenSslConfiguration.cmake)
else()
  add_definitions(-DORTHANC_SSL_ENABLED=0)
endif()

include(${CMAKE_SOURCE_DIR}/Resources/CMake/BoostConfiguration.cmake)

if(NOT ONLY_CORE_LIBRARY)
  include(${CMAKE_SOURCE_DIR}/Resources/CMake/DcmtkConfiguration.cmake)
endif()

include(${CMAKE_SOURCE_DIR}/Resources/CMake/MongooseConfiguration.cmake)
include(${CMAKE_SOURCE_DIR}/Resources/CMake/ZlibConfiguration.cmake)
include(${CMAKE_SOURCE_DIR}/Resources/CMake/SQLiteConfiguration.cmake)
include(${CMAKE_SOURCE_DIR}/Resources/CMake/JsonCppConfiguration.cmake)
include(${CMAKE_SOURCE_DIR}/Resources/CMake/LibCurlConfiguration.cmake)
include(${CMAKE_SOURCE_DIR}/Resources/CMake/LibPngConfiguration.cmake)


# Prepare the embedded files
set(EMBEDDED_FILES
  PREPARE_DATABASE ${CMAKE_CURRENT_SOURCE_DIR}/OrthancServer/PrepareDatabase.sql
  CONFIGURATION_SAMPLE ${CMAKE_CURRENT_SOURCE_DIR}/Resources/Configuration.json
  )

if (${STANDALONE_BUILD})
  # We embed all the resources in the binaries for standalone builds
  add_definitions(-DORTHANC_STANDALONE=1)
  EmbedResources(
    ${EMBEDDED_FILES}
    ORTHANC_EXPLORER ${CMAKE_CURRENT_SOURCE_DIR}/OrthancExplorer
    ${DCMTK_DICTIONARIES}
    )
else()
  add_definitions(
    -DORTHANC_STANDALONE=0
    -DORTHANC_PATH=\"${CMAKE_SOURCE_DIR}\"
    )
  EmbedResources(
    ${EMBEDDED_FILES}
    )
endif()



# The main instructions to build the Orthanc binaries
add_library(CoreLibrary
  STATIC
  ${AUTOGENERATED_SOURCES}
  ${THIRD_PARTY_SOURCES}

  Core/Cache/MemoryCache.cpp
  Core/ChunkedBuffer.cpp
  Core/Compression/BufferCompressor.cpp
  Core/Compression/ZlibCompressor.cpp
  Core/Compression/ZipWriter.cpp
  Core/Compression/HierarchicalZipWriter.cpp
  Core/OrthancException.cpp
  Core/DicomFormat/DicomArray.cpp
  Core/DicomFormat/DicomMap.cpp
  Core/DicomFormat/DicomTag.cpp
  Core/DicomFormat/DicomIntegerPixelAccessor.cpp
  Core/DicomFormat/DicomInstanceHasher.cpp
  Core/FileStorage/FileStorage.cpp
  Core/FileStorage/StorageAccessor.cpp
  Core/FileStorage/CompressedFileStorageAccessor.cpp
  Core/FileStorage/FileStorageAccessor.cpp
  Core/HttpServer/EmbeddedResourceHttpHandler.cpp
  Core/HttpServer/FilesystemHttpHandler.cpp
  Core/HttpServer/HttpHandler.cpp
  Core/HttpServer/HttpOutput.cpp
  Core/HttpServer/MongooseServer.cpp
  Core/HttpServer/HttpFileSender.cpp
  Core/HttpServer/FilesystemHttpSender.cpp
  Core/RestApi/RestApiPath.cpp
  Core/RestApi/RestApiOutput.cpp
  Core/RestApi/RestApi.cpp
  Core/MultiThreading/BagOfRunnablesBySteps.cpp
  Core/PngWriter.cpp
  Core/SQLite/Connection.cpp
  Core/SQLite/FunctionContext.cpp
  Core/SQLite/Statement.cpp
  Core/SQLite/StatementId.cpp
  Core/SQLite/StatementReference.cpp
  Core/SQLite/Transaction.cpp
  Core/Toolbox.cpp
  Core/Uuid.cpp

  OrthancCppClient/HttpClient.cpp
  OrthancCppClient/HttpException.cpp
  )  



if(NOT ONLY_CORE_LIBRARY)
  add_library(ServerLibrary
    ${DCMTK_SOURCES}
    OrthancServer/DicomProtocol/DicomFindAnswers.cpp
    OrthancServer/DicomProtocol/DicomServer.cpp
    OrthancServer/DicomProtocol/DicomUserConnection.cpp
    OrthancServer/FromDcmtkBridge.cpp
    OrthancServer/Internals/CommandDispatcher.cpp
    OrthancServer/Internals/FindScp.cpp
    OrthancServer/Internals/MoveScp.cpp
    OrthancServer/Internals/StoreScp.cpp
    OrthancServer/OrthancInitialization.cpp
    OrthancServer/OrthancRestApi.cpp
    OrthancServer/ServerIndex.cpp
    OrthancServer/ToDcmtkBridge.cpp
    OrthancServer/DatabaseWrapper.cpp
    OrthancServer/ServerContext.cpp
    OrthancServer/ServerEnumerations.cpp
    OrthancServer/ServerToolbox.cpp
    )

  # Ensure autogenerated code is built before building ServerLibrary
  add_dependencies(ServerLibrary CoreLibrary)

  add_executable(Orthanc
    OrthancServer/main.cpp
    )

  target_link_libraries(Orthanc ServerLibrary CoreLibrary)

  install(
    TARGETS Orthanc
    RUNTIME DESTINATION bin
    )

  # Build the unit tests if required
  if (BUILD_UNIT_TESTS)
    add_definitions(-DORTHANC_BUILD_UNIT_TESTS=1)
    include(${CMAKE_SOURCE_DIR}/Resources/CMake/GoogleTestConfiguration.cmake)
    add_executable(UnitTests
      ${GTEST_SOURCES}
      UnitTests/RestApi.cpp
      UnitTests/SQLite.cpp
      UnitTests/SQLiteChromium.cpp
      UnitTests/ServerIndex.cpp
      UnitTests/Versions.cpp
      UnitTests/Zip.cpp
      UnitTests/FileStorage.cpp
      UnitTests/MemoryCache.cpp
      UnitTests/main.cpp
      )
    target_link_libraries(UnitTests ServerLibrary CoreLibrary)
  endif()
endif()


# Generate the Doxygen documentation if Doxygen is present
find_package(Doxygen)
if (DOXYGEN_FOUND)
  configure_file(
    ${CMAKE_SOURCE_DIR}/Resources/Orthanc.doxygen
    ${CMAKE_CURRENT_BINARY_DIR}/Orthanc.doxygen
    @ONLY)
  add_custom_target(doc
    ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Orthanc.doxygen
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Generating API documentation with Doxygen" VERBATIM
    )
else()
  message("Doxygen not found. The documentation will not be built.")
endif()

=== OrthancCppClient/CMakeLists.txt ===
# Mini-project to check whether "OrthancCppClient" can compile in a
# standalone fashion

cmake_minimum_required(VERSION 2.8)

project(OrthancCppClientTest)

SET(STATIC_BUILD OFF)

include(${CMAKE_SOURCE_DIR}/../Resources/CMake/DownloadPackage.cmake)
include(${CMAKE_SOURCE_DIR}/../Resources/CMake/JsonCppConfiguration.cmake)
include(${CMAKE_SOURCE_DIR}/../Resources/CMake/LibCurlConfiguration.cmake)

if (${CMAKE_COMPILER_IS_GNUCXX})
  set(CMAKE_C_FLAGS "-Wall -pedantic -Wno-implicit-function-declaration")  # --std=c99 makes libcurl not to compile
  set(CMAKE_CXX_FLAGS "-Wall -pedantic -Wno-long-long -Wno-variadic-macros")
  set(CMAKE_EXE_LINKER_FLAGS "-Wl,--as-needed")
  set(CMAKE_SHARED_LINKER_FLAGS "-Wl,--no-undefined")
elseif (${MSVC})
  add_definitions(-D_CRT_SECURE_NO_WARNINGS=1)  
endif()

add_library(OrthancCppClient
  SHARED

  ${THIRD_PARTY_SOURCES}
  HttpException.cpp
  HttpClient.cpp
  )

add_executable(Test
  main.cpp
  )

target_link_libraries(Test OrthancCppClient)

=== Resources/Samples/RestApi/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(RestApiSample)

include(ExternalProject)

# Send the toolchain information to the Orthanc 
if (CMAKE_TOOLCHAIN_FILE)
  set(TOOLCHAIN "-DCMAKE_TOOLCHAIN_FILE=${CMAKE_TOOLCHAIN_FILE}")
endif()

ExternalProject_Add(
  ORTHANC_CORE

  # We use the Orthanc-0.3.1 branch for this sample
  DOWNLOAD_COMMAND hg clone https://code.google.com/p/orthanc/ -r Orthanc-0.3.1

  # Optional step, to reuse the third-party downloads
  PATCH_COMMAND ${CMAKE_COMMAND} -E create_symlink ${CMAKE_SOURCE_DIR}/../../../ThirdPartyDownloads ThirdPartyDownloads

  PREFIX ${CMAKE_BINARY_DIR}/Orthanc/
  UPDATE_COMMAND ""
  SOURCE_DIR ${CMAKE_BINARY_DIR}/Orthanc/src/orthanc/
  CMAKE_COMMAND ${CMAKE_COMMAND}
  CMAKE_ARGS -DSTATIC_BUILD=ON -DSTANDALONE_BUILD=ON -DUSE_DYNAMIC_GOOGLE_LOG=OFF -DUSE_DYNAMIC_SQLITE=OFF -DONLY_CORE_LIBRARY=ON -DENABLE_SSL=OFF ${TOOLCHAIN}
  BUILD_COMMAND $(MAKE)
  INSTALL_COMMAND ""
  BUILD_IN_SOURCE 0
  )

ExternalProject_Get_Property(ORTHANC_CORE source_dir)
include_directories(${source_dir})

ExternalProject_Get_Property(ORTHANC_CORE binary_dir)
link_directories(${binary_dir})
include_directories(${binary_dir}/jsoncpp-src-0.5.0/include)
include_directories(${binary_dir}/glog-0.3.2/src)
include_directories(${binary_dir}/boost_1_49_0)


add_executable(RestApiSample
  Sample.cpp
  )

add_dependencies(RestApiSample ORTHANC_CORE)

target_link_libraries(RestApiSample 
  # From Orthanc
  CoreLibrary
  GoogleLog

  # These two libraries are not necessary
  #OpenSSL
  #Curl
  )

if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
  target_link_libraries(RestApiSample pthread)
elseif (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
  add_definitions(-DGOOGLE_GLOG_DLL_DECL=)
  target_link_libraries(RestApiSample wsock32)
endif()

=== debian/changelog ===
orthanc (0.4.0-1) unstable; urgency=low

  * New upstream version.

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Mon, 17 Dec 2012 09:35:27 +0100

orthanc (0.2.3-1) unstable; urgency=low

  * New upstream version.

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Fri, 26 Oct 2012 16:35:11 +0200

orthanc (0.2.2-1) unstable; urgency=low

  * Initial release. (Closes: #689029)

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Thu, 04 Oct 2012 12:47:52 +0200

=== debian/control ===
Source: orthanc
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Sebastien Jodogne <s.jodogne@gmail.com>
Section: science
Priority: optional
Standards-Version: 3.9.3
Homepage: https://code.google.com/p/orthanc/
Build-Depends: debhelper (>= 9), cmake (>= 2.8), initscripts (>= 2.88dsf-13.3), unzip, uuid-dev, libssl-dev, zlib1g-dev, libpng-dev, libboost-all-dev, libwrap0-dev, libgoogle-glog-dev, libcurl4-openssl-dev | libcurl4-dev, libdcmtk2-dev, libsqlite3-dev, libjsoncpp-dev, libgtest-dev
Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/orthanc/trunk/
Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/orthanc/trunk/

Package: orthanc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, dcmtk
Description: RESTful DICOM server for healthcare and medical research
 Orthanc aims at providing a simple, yet powerful standalone DICOM
 server. Orthanc can turn any computer running Windows or Linux into a
 DICOM store (in other words, a mini-PACS system). Its architecture is
 lightweight, meaning that no complex database administration is
 required, nor the installation of third-party dependencies.
 .
 What makes Orthanc unique is the fact that it provides a RESTful
 API. Thanks to this major feature, it is possible to drive Orthanc
 from any computer language. The DICOM tags of the stored medical
 images can be downloaded in the JSON file format. Furthermore,
 standard PNG images can be generated on-the-fly from the DICOM
 instances by Orthanc.
 .
 Orthanc lets its users focus on the content of the DICOM files,
 hiding the complexity of the DICOM format and of the DICOM protocol.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --parallel --builddirectory=Build

override_dh_auto_configure:
	# Put 3rd party packages where the cmake build system expects them
	mkdir -p ThirdPartyDownloads
	( cd ThirdPartyDownloads; cp ../debian/ThirdPartyDownloads/* . )
	dh_auto_configure -- -DSTATIC_BUILD:BOOL=OFF -DSTANDALONE_BUILD:BOOL=ON -DUSE_DYNAMIC_JSONCPP:BOOL=ON -DDEBIAN_USE_GTEST_SOURCE_PACKAGE:BOOL=ON -DCMAKE_BUILD_TYPE=Release "-DDCMTK_LIBRARIES=wrap;oflog"

override_dh_auto_test:
	( cd $(CURDIR)/Build; ./UnitTests )

override_dh_clean:
	rm -rf ThirdPartyDownloads

override_dh_auto_install:
	dh_install Build/Orthanc usr/sbin

override_dh_installchangelogs:
	dh_installchangelogs -k $(CURDIR)/NEWS

get-orig-source:
	uscan --verbose --force-download --rename

## orthanc 0.5.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 # Version of the build, should always be "mainline" except in release branches
 add_definitions(
-  -DORTHANC_VERSION="0.4.0"
+  -DORTHANC_VERSION="0.5.2"
   )
 
 # Parameters of the build
@@ -18,6 +18,8 @@
 SET(USE_DYNAMIC_GOOGLE_LOG ON CACHE BOOL "Use the dynamic version of Google Log")
 SET(USE_DYNAMIC_GOOGLE_TEST ON CACHE BOOL "Use the dynamic version of Google Test (not for Debian sid)")
 SET(USE_DYNAMIC_SQLITE ON CACHE BOOL "Use the dynamic version of SQLite")
+SET(USE_DYNAMIC_MONGOOSE OFF CACHE BOOL "Use the dynamic version of Mongoose")
+SET(USE_DYNAMIC_LUA OFF CACHE BOOL "Use the dynamic version of Lua")
 SET(DEBIAN_FORCE_HARDENING OFF CACHE BOOL "Force the injection of Debian hardening flags (unrecommended)")
 SET(DEBIAN_USE_GTEST_SOURCE_PACKAGE OFF CACHE BOOL "Use the sources of Google Test shipped with libgtest-dev (only for Debian sid)")
 SET(ONLY_CORE_LIBRARY OFF CACHE BOOL "Only build the core library")
@@ -33,6 +35,7 @@
 # Some basic inclusions
 include(CheckIncludeFiles)
 include(CheckIncludeFileCXX)
+include(CheckLibraryExists)
 include(${CMAKE_SOURCE_DIR}/Resources/CMake/AutoGeneratedCode.cmake)
 include(${CMAKE_SOURCE_DIR}/Resources/CMake/DownloadPackage.cmake)
 include(${CMAKE_SOURCE_DIR}/Resources/CMake/Compiler.cmake)
@@ -71,12 +74,14 @@
 include(${CMAKE_SOURCE_DIR}/Resources/CMake/JsonCppConfiguration.cmake)
 include(${CMAKE_SOURCE_DIR}/Resources/CMake/LibCurlConfiguration.cmake)
 include(${CMAKE_SOURCE_DIR}/Resources/CMake/LibPngConfiguration.cmake)
+include(${CMAKE_SOURCE_DIR}/Resources/CMake/LuaConfiguration.cmake)
 
 
 # Prepare the embedded files
 set(EMBEDDED_FILES
   PREPARE_DATABASE ${CMAKE_CURRENT_SOURCE_DIR}/OrthancServer/PrepareDatabase.sql
   CONFIGURATION_SAMPLE ${CMAKE_CURRENT_SOURCE_DIR}/Resources/Configuration.json
+  LUA_TOOLBOX ${CMAKE_CURRENT_SOURCE_DIR}/Resources/Toolbox.lua
   )
 
 if (${STANDALONE_BUILD})
@@ -141,8 +146,11 @@
   Core/SQLite/Transaction.cpp
   Core/Toolbox.cpp
   Core/Uuid.cpp
+  Core/Lua/LuaContext.cpp
+  Core/Lua/LuaFunctionCall.cpp
 
   OrthancCppClient/HttpClient.cpp
+  OrthancCppClient/HttpEnumerations.cpp
   OrthancCppClient/HttpException.cpp
   )  
 
@@ -150,6 +158,7 @@
 
 if(NOT ONLY_CORE_LIBRARY)
   add_library(ServerLibrary
+    STATIC
     ${DCMTK_SOURCES}
     OrthancServer/DicomProtocol/DicomFindAnswers.cpp
     OrthancServer/DicomProtocol/DicomServer.cpp
@@ -189,14 +198,16 @@
     include(${CMAKE_SOURCE_DIR}/Resources/CMake/GoogleTestConfiguration.cmake)
     add_executable(UnitTests
       ${GTEST_SOURCES}
+      UnitTests/FileStorage.cpp
+      UnitTests/MemoryCache.cpp
+      UnitTests/PngWriter.cpp
       UnitTests/RestApi.cpp
       UnitTests/SQLite.cpp
       UnitTests/SQLiteChromium.cpp
       UnitTests/ServerIndex.cpp
       UnitTests/Versions.cpp
       UnitTests/Zip.cpp
-      UnitTests/FileStorage.cpp
-      UnitTests/MemoryCache.cpp
+      UnitTests/Lua.cpp
       UnitTests/main.cpp
       )
     target_link_libraries(UnitTests ServerLibrary CoreLibrary)

=== Resources/Samples/RestApiLinuxDynamic/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(RestApiSample)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -std=c++0x")

file(DOWNLOAD 
  http://mongoose.googlecode.com/files/mongoose-3.1.tgz 
  ${CMAKE_BINARY_DIR}/mongoose-3.1.tar.gz
  EXPECTED_MD5 "e718fc287b4eb1bd523be3fa00942bb0"
  SHOW_PROGRESS
  )

file(DOWNLOAD 
  http://downloads.sourceforge.net/project/jsoncpp/jsoncpp/0.5.0/jsoncpp-src-0.5.0.tar.gz
  ${CMAKE_BINARY_DIR}/jsoncpp-src-0.5.0.tar.gz
  EXPECTED_MD5 "24482b67c1cb17aac1ed1814288a3a8f"
  SHOW_PROGRESS
  )

execute_process(
  COMMAND hg clone -v -r Orthanc-0.4.0 https://code.google.com/p/orthanc/ Orthanc-0.4.0
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
  )

execute_process(
  COMMAND ${CMAKE_COMMAND} -E tar xvfz ${CMAKE_BINARY_DIR}/mongoose-3.1.tar.gz
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
  )

# Apply a patch to improve Mongoose shutdown
execute_process(
  COMMAND patch mongoose.c ${ORTHANC_DIR}/Resources/Patches/mongoose-patch.diff
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/mongoose
  )

execute_process(
  COMMAND ${CMAKE_COMMAND} -E tar xvfz ${CMAKE_BINARY_DIR}/jsoncpp-src-0.5.0.tar.gz
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
  )

include(AutoGeneratedCode.cmake)

add_definitions(
  -DBOOST_HAS_FILESYSTEM_V3=1
  -DBOOST_HAS_SCHED_YIELD=1
  -DORTHANC_SSL_ENABLED=1
  -DORTHANC_STANDALONE=1
  -DORTHANC_STATIC=0
  )

set(ORTHANC_DIR ${CMAKE_BINARY_DIR}/Orthanc-0.4.0)
set(MONGOOSE_DIR ${CMAKE_BINARY_DIR}/mongoose)
set(JSONCPP_DIR ${CMAKE_BINARY_DIR}/jsoncpp-src-0.5.0)

include_directories(
  ${ORTHANC_DIR}
  ${MONGOOSE_DIR}
  ${JSONCPP_DIR}/include
  )

link_libraries(
  boost_date_time
  boost_filesystem
  boost_system
  boost_thread
  curl
  dl
  glog
  png
  pthread
  sqlite3
  uuid
  z
  )

set(THIRD_PARTY_SOURCES
  ${MONGOOSE_DIR}/mongoose.c
  ${JSONCPP_DIR}/src/lib_json/json_reader.cpp
  ${JSONCPP_DIR}/src/lib_json/json_value.cpp 
  ${JSONCPP_DIR}/src/lib_json/json_writer.cpp
  )

file(GLOB ORTHANC_SOURCES 
  ${ORTHANC_DIR}/Core/*.cpp
  ${ORTHANC_DIR}/Core/*/*.cpp
  ${ORTHANC_DIR}/OrthancCppClient/*.cpp
  ${ORTHANC_DIR}/Resources/base64/base64.cpp
  ${ORTHANC_DIR}/Resources/md5/md5.c
  ${ORTHANC_DIR}/Resources/sha1/sha1.cpp
  ${ORTHANC_DIR}/Resources/minizip/zip.c
  ${ORTHANC_DIR}/Resources/minizip/ioapi.c
  )

list(REMOVE_ITEM ORTHANC_SOURCES ${ORTHANC_DIR}/OrthancCppClient/main.cpp)

EmbedResources(
  #ORTHANC_EXPLORER ${ORTHANC_DIR}/OrthancExplorer
  )

add_executable(RestApiSample
  Sample.cpp
  ${ORTHANC_SOURCES}
  ${AUTOGENERATED_SOURCES}
  ${THIRD_PARTY_SOURCES}
  )

=== debian/changelog ===
orthanc (0.5.2-1) unstable; urgency=low

  [ Sebastien Jodogne ]
  * New upstream version: 0.5.2

  [ Mathieu Malaterre ]
  * Use boost1.53 explicitely, until #704032 happens

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Wed, 08 May 2013 14:27:23 +0200

orthanc (0.5.1-1) unstable; urgency=low

  [ Sebastien Jodogne ]
  * New upstream version: 0.5.1
  * Handle RGB DICOM. Closes: #698417

  [ Mathieu Malaterre ]
  * Remove patches applied upstrea:
    + debian/patches/cmake-new-platforms
    + debian/patches/freebsd-hurd-fixes

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Wed, 17 Apr 2013 14:23:03 +0200

orthanc (0.5.0-2) unstable; urgency=low

  * Fixes for kFreeBSD and Hurd

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Thu, 07 Mar 2013 10:20:15 +0100

orthanc (0.5.0-1) unstable; urgency=low

  [ Sebastien Jodogne ]
  * New upstream version.

  [ Mathieu Malaterre ]
  * Team upload.
  * Add README.Debian to get started with Orthanc
  * (wrap-and-sort): Fix B-D for libgtest-dev. Closes: #698415
  * Bump Std-Vers to 3.9.4, no changes needed
  * Remove unzip from B-D (not needed)
  * Cleanup d/rules (-DNDEBUG in build logs)

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Tue, 05 Mar 2013 12:38:03 +0100

=== debian/control ===
--- 
+++ 
@@ -3,15 +3,30 @@
 Uploaders: Sebastien Jodogne <s.jodogne@gmail.com>
 Section: science
 Priority: optional
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
 Homepage: https://code.google.com/p/orthanc/
-Build-Depends: debhelper (>= 9), cmake (>= 2.8), initscripts (>= 2.88dsf-13.3), unzip, uuid-dev, libssl-dev, zlib1g-dev, libpng-dev, libboost-all-dev, libwrap0-dev, libgoogle-glog-dev, libcurl4-openssl-dev | libcurl4-dev, libdcmtk2-dev, libsqlite3-dev, libjsoncpp-dev, libgtest-dev
+Build-Depends: cmake (>= 2.8),
+               debhelper (>= 9),
+               initscripts (>= 2.88dsf-13.3),
+               libboost1.53-all-dev,
+               libcurl4-openssl-dev | libcurl4-dev,
+               libdcmtk2-dev,
+               libgoogle-glog-dev,
+               libgtest-dev (>= 1.6.0),
+               libjsoncpp-dev,
+               liblua5.1-0-dev (>= 5.1.0),
+               libpng-dev,
+               libsqlite3-dev,
+               libssl-dev,
+               libwrap0-dev,
+               uuid-dev,
+               zlib1g-dev
 Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/orthanc/trunk/
 Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/orthanc/trunk/
 
 Package: orthanc
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, dcmtk
+Depends: adduser, dcmtk, ${misc:Depends}, ${shlibs:Depends}
 Description: RESTful DICOM server for healthcare and medical research
  Orthanc aims at providing a simple, yet powerful standalone DICOM
  server. Orthanc can turn any computer running Windows or Linux into a

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --parallel --builddirectory=Build

CMAKE_EXTRA_FLAGS += \
	-DSTATIC_BUILD:BOOL=OFF \
	-DSTANDALONE_BUILD:BOOL=ON \
	-DUSE_DYNAMIC_JSONCPP:BOOL=ON \
	-DUSE_DYNAMIC_LUA:BOOL=ON \
	-DUSE_DYNAMIC_MONGOOSE:BOOL=OFF \
	-DDEBIAN_USE_GTEST_SOURCE_PACKAGE:BOOL=ON \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo \
	-DDCMTK_LIBRARIES="wrap;oflog"

override_dh_auto_configure:
	# Put 3rd party packages where the cmake build system expects them
	mkdir -p ThirdPartyDownloads
	( cd ThirdPartyDownloads; cp ../debian/ThirdPartyDownloads/* . )
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

override_dh_auto_test:
	( cd Build; ./UnitTests )

override_dh_clean:
	rm -rf ThirdPartyDownloads
	dh_clean

override_dh_auto_install:
	dh_install Build/Orthanc usr/sbin

override_dh_installchangelogs:
	dh_installchangelogs -k NEWS

get-orig-source:
	uscan --verbose --force-download --rename

## orthanc 0.6.2

=== debian/changelog ===
orthanc (0.6.2-1) unstable; urgency=low

  [ Sebastien Jodogne ]
  * New upstream version: 0.6.2
  * Packaging of the Orthanc Client library (liborthancclient*)
  * Fix licensing issue with the SHA-1 library. Closes: #724947

  [ Andreas Tille ]
  * debian/control: use anonscm in Vcs fields

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Mon, 07 Oct 2013 10:56:38 +0200

orthanc (0.6.1-1) unstable; urgency=low

  * New upstream version: 0.6.1

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Mon, 16 Sep 2013 15:13:44 +0200

orthanc (0.6.0-1) unstable; urgency=low

  [ Sebastien Jodogne ]
  * New upstream version: 0.6.0
  * Fix image preview. Closes: #716958
  * Fix missing copyright information. Closes: #712038
  * Remove explicit dependency on boost1.53

  [ Mathieu Malaterre ]
  * Remove RelWithDebInfo, because of change in behavior in cmake

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Wed, 17 Jul 2013 10:55:49 +0200

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
 Build-Depends: cmake (>= 2.8),
                debhelper (>= 9),
                initscripts (>= 2.88dsf-13.3),
-               libboost1.53-all-dev,
+               libboost-all-dev,
                libcurl4-openssl-dev | libcurl4-dev,
                libdcmtk2-dev,
                libgoogle-glog-dev,
@@ -20,9 +20,10 @@
                libssl-dev,
                libwrap0-dev,
                uuid-dev,
-               zlib1g-dev
-Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/orthanc/trunk/
-Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/orthanc/trunk/
+               zlib1g-dev,
+	       doxygen
+Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/orthanc/trunk/
+Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/orthanc/trunk/
 
 Package: orthanc
 Architecture: any
@@ -43,3 +44,36 @@
  .
  Orthanc lets its users focus on the content of the DICOM files,
  hiding the complexity of the DICOM format and of the DICOM protocol.
+
+Package: liborthancclient0.6
+Section: libs
+Architecture: any
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Description: Orthanc Client runtime library
+ Orthanc Client is a library to access the content of a remote
+ instance of Orthanc. Orthanc is a lightweight, RESTful DICOM server
+ for healthcare and medical research.
+ .
+ This package includes the client library.
+
+Package: liborthancclient-dev
+Architecture: any
+Section: libdevel
+Depends: liborthancclient0.6 (= ${binary:Version}), ${misc:Depends}
+Description: Orthanc Client development files
+ Orthanc Client is a library to access the content of a remote
+ instance of Orthanc. Orthanc is a lightweight, RESTful DICOM server
+ for healthcare and medical research.
+ .
+ This package includes the header files for C++ code.
+
+Package: liborthancclient-doc
+Architecture: all
+Section: doc
+Depends: ${misc:Depends}
+Description: Orthanc Client documentation
+ Orthanc Client is a library to access the content of a remote
+ instance of Orthanc. Orthanc is a lightweight, RESTful DICOM server
+ for healthcare and medical research.
+ .
+ This package includes the documentation and the sample codes.

=== debian/rules ===
#!/usr/bin/make -f

export DESTDIR := $(CURDIR)/debian/tmp
export CLIENT_SAMPLES_DIR := $(DESTDIR)/usr/share/doc/orthanc/OrthancClientSamples

%:
	dh $@ --parallel --builddirectory=Build

CMAKE_EXTRA_FLAGS += \
	-DCMAKE_SKIP_RPATH=ON \
	-DSTATIC_BUILD:BOOL=OFF \
	-DSTANDALONE_BUILD:BOOL=ON \
	-DUSE_DYNAMIC_JSONCPP:BOOL=ON \
	-DUSE_DYNAMIC_LUA:BOOL=ON \
	-DUSE_DYNAMIC_MONGOOSE:BOOL=OFF \
	-DDEBIAN_USE_GTEST_SOURCE_PACKAGE:BOOL=ON \
	-DDCMTK_DICTIONARY_DIR:PATH=/usr/share/libdcmtk2 \
	-DCMAKE_BUILD_TYPE=""   # The build type must be left empty, see #711515

override_dh_auto_configure:
        # Put 3rd party packages where the cmake build system expects them
	mkdir -p ThirdPartyDownloads
	( cd ThirdPartyDownloads; cp ../debian/ThirdPartyDownloads/* . )
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

override_dh_auto_test:
	( cd Build; ./UnitTests )

override_dh_clean:
	rm -rf ThirdPartyDownloads
	dh_clean

override_dh_auto_install:
        # Move the samples of the Orthanc Client
	mkdir -p $(CLIENT_SAMPLES_DIR)
	cp -r Resources/Samples/OrthancClient/* $(CLIENT_SAMPLES_DIR)

	dh_auto_install

        # Move the Orthanc binaries to "/usr/sbin"
	dh_install Build/Orthanc usr/sbin

override_dh_installchangelogs:
	dh_installchangelogs -k NEWS

get-orig-source:
	uscan --verbose --force-download --rename

## orthanc 0.7.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(Orthanc)

# Version of the build, should always be "mainline" except in release branches
set(ORTHANC_VERSION "0.7.2")


#####################################################################
## CMake parameters tunable at the command line
#####################################################################

# Parameters of the build
SET(STATIC_BUILD OFF CACHE BOOL "Static build of the third-party libraries (necessary for Windows)")
SET(STANDALONE_BUILD ON CACHE BOOL "Standalone build (all the resources are embedded, necessary for releases)")
SET(ENABLE_SSL ON CACHE BOOL "Include support for SSL")
SET(BUILD_CLIENT_LIBRARY ON CACHE BOOL "Build the client library")
SET(DCMTK_DICTIONARY_DIR "/usr/share/dcmtk" CACHE PATH "Directory containing the DCMTK dictionaries \"dicom.dic\" and \"private.dic\" (only when using system version of DCMTK)") 
SET(ALLOW_DOWNLOADS OFF CACHE BOOL "Allow CMake to download packages")

# Advanced parameters to fine-tune linking against system libraries
SET(USE_SYSTEM_JSONCPP ON CACHE BOOL "Use the system version of JsonCpp")
SET(USE_SYSTEM_GOOGLE_LOG ON CACHE BOOL "Use the system version of Google Log")
SET(USE_SYSTEM_GOOGLE_TEST ON CACHE BOOL "Use the system version of Google Test")
SET(USE_SYSTEM_SQLITE ON CACHE BOOL "Use the system version of SQLite")
SET(USE_SYSTEM_MONGOOSE ON CACHE BOOL "Use the system version of Mongoose")
SET(USE_SYSTEM_LUA ON CACHE BOOL "Use the system version of Lua")
SET(USE_SYSTEM_DCMTK ON CACHE BOOL "Use the system version of DCMTK")
SET(USE_SYSTEM_BOOST ON CACHE BOOL "Use the system version of Boost")
SET(USE_SYSTEM_LIBPNG ON CACHE BOOL "Use the system version of LibPng")
SET(USE_SYSTEM_CURL ON CACHE BOOL "Use the system version of LibCurl")

# Distribution-specific settings
SET(USE_GTEST_DEBIAN_SOURCE_PACKAGE OFF CACHE BOOL "Use the sources of Google Test shipped with libgtest-dev (Debian only)")
mark_as_advanced(USE_GTEST_DEBIAN_SOURCE_PACKAGE)

# Some basic inclusions
include(CheckIncludeFiles)
include(CheckIncludeFileCXX)
include(CheckLibraryExists)
include(${CMAKE_SOURCE_DIR}/Resources/CMake/AutoGeneratedCode.cmake)
include(${CMAKE_SOURCE_DIR}/Resources/CMake/DownloadPackage.cmake)
include(${CMAKE_SOURCE_DIR}/Resources/CMake/Compiler.cmake)

set(ORTHANC_ROOT ${CMAKE_SOURCE_DIR})




#####################################################################
## Inclusion of third-party dependencies
#####################################################################

# Configuration of the standalone builds
if (CMAKE_CROSSCOMPILING)
  # Cross-compilation implies the standalone build
  SET(STANDALONE_BUILD ON)
endif()

# Prepare the third-party dependencies
SET(THIRD_PARTY_SOURCES
  ${CMAKE_SOURCE_DIR}/Resources/md5/md5.c
  ${CMAKE_SOURCE_DIR}/Resources/base64/base64.cpp
  )

include(${CMAKE_SOURCE_DIR}/Resources/CMake/GoogleLogConfiguration.cmake)

if (${ENABLE_SSL})
  add_definitions(-DORTHANC_SSL_ENABLED=1)
  include(${CMAKE_SOURCE_DIR}/Resources/CMake/OpenSslConfiguration.cmake)
else()
  add_definitions(-DORTHANC_SSL_ENABLED=0)
endif()

include(${CMAKE_SOURCE_DIR}/Resources/CMake/BoostConfiguration.cmake)
include(${CMAKE_SOURCE_DIR}/Resources/CMake/DcmtkConfiguration.cmake)
include(${CMAKE_SOURCE_DIR}/Resources/CMake/MongooseConfiguration.cmake)
include(${CMAKE_SOURCE_DIR}/Resources/CMake/ZlibConfiguration.cmake)
include(${CMAKE_SOURCE_DIR}/Resources/CMake/SQLiteConfiguration.cmake)
include(${CMAKE_SOURCE_DIR}/Resources/CMake/JsonCppConfiguration.cmake)
include(${CMAKE_SOURCE_DIR}/Resources/CMake/LibCurlConfiguration.cmake)
include(${CMAKE_SOURCE_DIR}/Resources/CMake/LibPngConfiguration.cmake)
include(${CMAKE_SOURCE_DIR}/Resources/CMake/LuaConfiguration.cmake)



#####################################################################
## Autogeneration of files
#####################################################################

# Prepare the embedded files
set(EMBEDDED_FILES
  PREPARE_DATABASE ${CMAKE_CURRENT_SOURCE_DIR}/OrthancServer/PrepareDatabase.sql
  CONFIGURATION_SAMPLE ${CMAKE_CURRENT_SOURCE_DIR}/Resources/Configuration.json
  LUA_TOOLBOX ${CMAKE_CURRENT_SOURCE_DIR}/Resources/Toolbox.lua
  )

if (${STANDALONE_BUILD})
  # We embed all the resources in the binaries for standalone builds
  add_definitions(-DORTHANC_STANDALONE=1)
  EmbedResources(
    ${EMBEDDED_FILES}
    ORTHANC_EXPLORER ${CMAKE_CURRENT_SOURCE_DIR}/OrthancExplorer
    ${DCMTK_DICTIONARIES}
    )
else()
  add_definitions(
    -DORTHANC_STANDALONE=0
    -DORTHANC_PATH=\"${CMAKE_SOURCE_DIR}\"
    )
  EmbedResources(
    ${EMBEDDED_FILES}
    )
endif()



#####################################################################
## Build the core of Orthanc
#####################################################################

add_definitions(
  -DORTHANC_VERSION="${ORTHANC_VERSION}"
  )

list(LENGTH OPENSSL_SOURCES OPENSSL_SOURCES_LENGTH)
if (${OPENSSL_SOURCES_LENGTH} GREATER 0)
  add_library(OpenSSL STATIC ${OPENSSL_SOURCES})
endif()

add_library(CoreLibrary
  STATIC
  ${AUTOGENERATED_SOURCES}
  ${THIRD_PARTY_SOURCES}
  ${CURL_SOURCES}

  Core/Cache/MemoryCache.cpp
  Core/ChunkedBuffer.cpp
  Core/Compression/BufferCompressor.cpp
  Core/Compression/ZlibCompressor.cpp
  Core/Compression/ZipWriter.cpp
  Core/Compression/HierarchicalZipWriter.cpp
  Core/OrthancException.cpp
  Core/DicomFormat/DicomArray.cpp
  Core/DicomFormat/DicomMap.cpp
  Core/DicomFormat/DicomTag.cpp
  Core/DicomFormat/DicomIntegerPixelAccessor.cpp
  Core/DicomFormat/DicomInstanceHasher.cpp
  Core/Enumerations.cpp
  Core/FileStorage/FileStorage.cpp
  Core/FileStorage/StorageAccessor.cpp
  Core/FileStorage/CompressedFileStorageAccessor.cpp
  Core/FileStorage/FileStorageAccessor.cpp
  Core/HttpClient.cpp
  Core/HttpServer/EmbeddedResourceHttpHandler.cpp
  Core/HttpServer/FilesystemHttpHandler.cpp
  Core/HttpServer/HttpHandler.cpp
  Core/HttpServer/HttpOutput.cpp
  Core/HttpServer/MongooseServer.cpp
  Core/HttpServer/HttpFileSender.cpp
  Core/HttpServer/FilesystemHttpSender.cpp
  Core/RestApi/RestApiPath.cpp
  Core/RestApi/RestApiOutput.cpp
  Core/RestApi/RestApi.cpp
  Core/MultiThreading/BagOfRunnablesBySteps.cpp
  Core/MultiThreading/SharedMessageQueue.cpp
  Core/MultiThreading/ThreadedCommandProcessor.cpp
  Core/MultiThreading/ArrayFilledByThreads.cpp
  Core/FileFormats/PngReader.cpp
  Core/FileFormats/PngWriter.cpp
  Core/SQLite/Connection.cpp
  Core/SQLite/FunctionContext.cpp
  Core/SQLite/Statement.cpp
  Core/SQLite/StatementId.cpp
  Core/SQLite/StatementReference.cpp
  Core/SQLite/Transaction.cpp
  Core/Toolbox.cpp
  Core/Uuid.cpp
  Core/Lua/LuaContext.cpp
  Core/Lua/LuaFunctionCall.cpp

  OrthancCppClient/OrthancConnection.cpp
  OrthancCppClient/Study.cpp
  OrthancCppClient/Series.cpp
  OrthancCppClient/Instance.cpp
  OrthancCppClient/Patient.cpp
  )  


#####################################################################
## Build the Orthanc server
#####################################################################

add_library(ServerLibrary
  STATIC
  ${DCMTK_SOURCES}
  OrthancServer/DicomProtocol/DicomFindAnswers.cpp
  OrthancServer/DicomProtocol/DicomServer.cpp
  OrthancServer/DicomProtocol/DicomUserConnection.cpp
  OrthancServer/FromDcmtkBridge.cpp
  OrthancServer/Internals/CommandDispatcher.cpp
  OrthancServer/Internals/FindScp.cpp
  OrthancServer/Internals/MoveScp.cpp
  OrthancServer/Internals/StoreScp.cpp
  OrthancServer/OrthancInitialization.cpp
  OrthancServer/OrthancRestApi.cpp
  OrthancServer/ServerIndex.cpp
  OrthancServer/ToDcmtkBridge.cpp
  OrthancServer/DatabaseWrapper.cpp
  OrthancServer/ServerContext.cpp
  OrthancServer/ServerEnumerations.cpp
  OrthancServer/ServerToolbox.cpp
  OrthancServer/OrthancFindRequestHandler.cpp
  OrthancServer/OrthancMoveRequestHandler.cpp
  )

# Ensure autogenerated code is built before building ServerLibrary
add_dependencies(ServerLibrary CoreLibrary)

add_executable(Orthanc
  OrthancServer/main.cpp
  )

target_link_libraries(Orthanc ServerLibrary CoreLibrary)

if (${OPENSSL_SOURCES_LENGTH} GREATER 0)
  target_link_libraries(Orthanc OpenSSL)
endif()

install(
  TARGETS Orthanc
  RUNTIME DESTINATION sbin
  )



#####################################################################
## Build the unit tests
#####################################################################

add_definitions(-DORTHANC_BUILD_UNIT_TESTS=1)
include(${CMAKE_SOURCE_DIR}/Resources/CMake/GoogleTestConfiguration.cmake)
add_executable(UnitTests
  ${GTEST_SOURCES}
  UnitTestsSources/FileStorage.cpp
  UnitTestsSources/MemoryCache.cpp
  UnitTestsSources/Png.cpp
  UnitTestsSources/RestApi.cpp
  UnitTestsSources/SQLite.cpp
  UnitTestsSources/SQLiteChromium.cpp
  UnitTestsSources/ServerIndex.cpp
  UnitTestsSources/Versions.cpp
  UnitTestsSources/Zip.cpp
  UnitTestsSources/Lua.cpp
  UnitTestsSources/main.cpp
  )
target_link_libraries(UnitTests ServerLibrary CoreLibrary)

if (${OPENSSL_SOURCES_LENGTH} GREATER 0)
  target_link_libraries(UnitTests OpenSSL)
endif()



#####################################################################
## Create the standalone DLL containing the Orthanc Client API
#####################################################################

if (BUILD_CLIENT_LIBRARY)
  include_directories(${ORTHANC_ROOT}/OrthancCppClient/SharedLibrary/Laaw)

  if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
    if (CMAKE_CROSSCOMPILING)
      # Remove the default "lib" prefix from "libOrthancClient.dll" if cross-compiling
      set(CMAKE_SHARED_LIBRARY_PREFIX "")

      if (${CMAKE_SIZEOF_VOID_P} EQUAL 4)
        set(ORTHANC_CPP_CLIENT_AUX ${ORTHANC_ROOT}/OrthancCppClient/SharedLibrary/AUTOGENERATED/Windows32.def)
      elseif (${CMAKE_SIZEOF_VOID_P} EQUAL 8)
        set(ORTHANC_CPP_CLIENT_AUX ${ORTHANC_ROOT}/OrthancCppClient/SharedLibrary/AUTOGENERATED/Windows64.def)
      else()
        message(FATAL_ERROR "Support your platform here")
      endif()
    else()
      # Nothing to do if using Visual Studio
    endif()

    if (${CMAKE_SIZEOF_VOID_P} EQUAL 4)
      set(CMAKE_SHARED_LIBRARY_SUFFIX "_Windows32.dll")
      list(APPEND ORTHANC_CPP_CLIENT_AUX ${ORTHANC_ROOT}/OrthancCppClient/SharedLibrary/AUTOGENERATED/Windows32.rc)
    elseif (${CMAKE_SIZEOF_VOID_P} EQUAL 8)
      set(CMAKE_SHARED_LIBRARY_SUFFIX "_Windows64.dll")
      list(APPEND ORTHANC_CPP_CLIENT_AUX ${ORTHANC_ROOT}/OrthancCppClient/SharedLibrary/AUTOGENERATED/Windows64.rc)
    else()
      message(FATAL_ERROR "Support your platform here")
    endif()    

  else()
    set(ORTHANC_CPP_CLIENT_AUX ${OPENSSL_SOURCES})
  endif()

  add_library(OrthancClient SHARED
    ${ORTHANC_ROOT}/Core/OrthancException.cpp
    ${ORTHANC_ROOT}/Core/Enumerations.cpp
    ${ORTHANC_ROOT}/Core/Toolbox.cpp
    ${ORTHANC_ROOT}/Core/HttpClient.cpp
    ${ORTHANC_ROOT}/Core/MultiThreading/ArrayFilledByThreads.cpp
    ${ORTHANC_ROOT}/Core/MultiThreading/ThreadedCommandProcessor.cpp
    ${ORTHANC_ROOT}/Core/MultiThreading/SharedMessageQueue.cpp
    ${ORTHANC_ROOT}/Core/FileFormats/PngReader.cpp
    ${ORTHANC_ROOT}/OrthancCppClient/OrthancConnection.cpp
    ${ORTHANC_ROOT}/OrthancCppClient/Series.cpp
    ${ORTHANC_ROOT}/OrthancCppClient/Study.cpp
    ${ORTHANC_ROOT}/OrthancCppClient/Instance.cpp
    ${ORTHANC_ROOT}/OrthancCppClient/Patient.cpp
    ${ORTHANC_ROOT}/OrthancCppClient/SharedLibrary/SharedLibrary.cpp
    ${ORTHANC_ROOT}/Resources/md5/md5.c
    ${ORTHANC_ROOT}/Resources/base64/base64.cpp
    ${ORTHANC_CPP_CLIENT_AUX}
    ${THIRD_PARTY_SOURCES}
    ${CURL_SOURCES}
    )

  if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
    set_target_properties(OrthancClient
      PROPERTIES LINK_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined -Wl,--as-needed -Wl,--version-script=${ORTHANC_ROOT}/OrthancCppClient/SharedLibrary/Laaw/VersionScript.map"
      )
    target_link_libraries(OrthancClient pthread)

  elseif (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
    target_link_libraries(OrthancClient OpenSSL ws2_32)

    if (CMAKE_CROSSCOMPILING)
      set_target_properties(OrthancClient

=== Resources/Samples/OrthancClient/Basic/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(Basic)

add_executable(Test main.cpp)

if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
  # Linking with "pthread" is necessary, otherwise the software crashes
  # http://sourceware.org/bugzilla/show_bug.cgi?id=10652#c17
  target_link_libraries(Test pthread dl)
endif()

=== Resources/Samples/OrthancClient/Vtk/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(Vtk)

find_package(VTK REQUIRED)
include(${VTK_USE_FILE})

add_executable(Test
  main.cpp
  )

# Linking with "pthread" is necessary, otherwise the software crashes
# http://sourceware.org/bugzilla/show_bug.cgi?id=10652#c17
target_link_libraries(Test pthread dl)

if(VTK_LIBRARIES)
  target_link_libraries(Test ${VTK_LIBRARIES})
else()
  target_link_libraries(Test vtkHybrid vtkVolumeRendering)
endif()

=== debian/changelog ===
orthanc (0.7.2-1) unstable; urgency=low

  [ Sebastien Jodogne ]
  * New upstream version: 0.7.2
  * Support big-endian architectures. Closes: #728822

  [ Andreas Tille ]
  * debian/control:
     - Build-Depends: unzip
     - Standards-Version: 3.9.5

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Tue, 03 Dec 2013 11:30:41 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Uploaders: Sebastien Jodogne <s.jodogne@gmail.com>
 Section: science
 Priority: optional
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Homepage: https://code.google.com/p/orthanc/
 Build-Depends: cmake (>= 2.8),
                debhelper (>= 9),
@@ -21,7 +21,8 @@
                libwrap0-dev,
                uuid-dev,
                zlib1g-dev,
-	       doxygen
+	       doxygen,
+               unzip
 Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/orthanc/trunk/
 Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/orthanc/trunk/
 
@@ -45,7 +46,7 @@
  Orthanc lets its users focus on the content of the DICOM files,
  hiding the complexity of the DICOM format and of the DICOM protocol.
 
-Package: liborthancclient0.6
+Package: liborthancclient0.7
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -59,7 +60,7 @@
 Package: liborthancclient-dev
 Architecture: any
 Section: libdevel
-Depends: liborthancclient0.6 (= ${binary:Version}), ${misc:Depends}
+Depends: liborthancclient0.7 (= ${binary:Version}), ${misc:Depends}
 Description: Orthanc Client development files
  Orthanc Client is a library to access the content of a remote
  instance of Orthanc. Orthanc is a lightweight, RESTful DICOM server

=== debian/rules ===
--- 
+++ 
@@ -10,10 +10,8 @@
 	-DCMAKE_SKIP_RPATH=ON \
 	-DSTATIC_BUILD:BOOL=OFF \
 	-DSTANDALONE_BUILD:BOOL=ON \
-	-DUSE_DYNAMIC_JSONCPP:BOOL=ON \
-	-DUSE_DYNAMIC_LUA:BOOL=ON \
-	-DUSE_DYNAMIC_MONGOOSE:BOOL=OFF \
-	-DDEBIAN_USE_GTEST_SOURCE_PACKAGE:BOOL=ON \
+	-DUSE_SYSTEM_MONGOOSE:BOOL=OFF \
+	-DUSE_GTEST_DEBIAN_SOURCE_PACKAGE:BOOL=ON \
 	-DDCMTK_DICTIONARY_DIR:PATH=/usr/share/libdcmtk2 \
 	-DCMAKE_BUILD_TYPE=""   # The build type must be left empty, see #711515

=== debian/watch ===
version=3
http://code.google.com/p/orthanc/downloads/list?can=1 .*/Orthanc-(\d[\d.]*)\.(?:zip|tgz|tbz2|txz|tar\.gz|tar\.bz2|tar\.xz)
